#define AllocUnit 64
enum {	MemeVMutIntvl, MemeVPlant, MemeVMove, MemeVSaveFoods,
	MemeLenV
};
enum {
	MemeCDelivery = 0, MemeCMutIntvl,
	MemeCWd, MemeCWo, MemeCWp, MemeCBd, MemeCBo, MemeCBp,
	MemeCMilRatio, MemeCInvade,
	MemeLenC
};

typedef struct land {
	struct land *pre, *post;
	struct village *v;
	int x, y, work;
} Land;

typedef struct {
	unsigned char r, g, b;
} MyRGB;

enum {
	NoAttacked, Attacked, AttackedThenOccupied
};
typedef struct village {
	struct village	*pre, *post;
	struct country	*k;
	struct land	*l;
	void	*border;
	int	nLands;
	unsigned long	id;
	unsigned long	ageM;
	long	p, po, ps, pp;	// officer, soldier, producer
	double	sv, surplus, fd, richness;
	int	plantation;	// action
	struct country	*moveTo;
	unsigned char	meme[MemeLenV];
	unsigned char	work;	// used in checkSepAndRuin in country.c
	unsigned char	attacked;
	MyRGB	rgb;
} Village;

typedef struct {
	int	nv, p;
	double	sv;
	unsigned char meme[MemeLenC];
} CountryLog;
#define	CLogLength	20

typedef struct country {
	struct country	*pre, *post;
	struct village	*v;
	void	*border;
	unsigned long	nVillages;
	unsigned long	id;
	unsigned long	age, ageM;
	long	p;		// population
	double	sv;		// food stock
	double	richness;
	unsigned long	mil, newMil;	// size of military
	unsigned long	warDead;
	unsigned char	meme[MemeLenC];
	unsigned char	work;
	MyRGB	rgb;
	int	nVindependent, nVmoveOut, nVmoveIn;
	int	logIndex;
	CountryLog	log[CLogLength];
} Country;

typedef struct {
	int	n;
	double	min, max;
	double	*data;
	int	index, size;
} LogData;
typedef struct {
	int	n;
	int	min, max;
	int	*data;
	int	index, size;
} LogDataInt;

enum {
	FnDelivery	= 0x01,
	FnWar		= 0x02,
	FnNoOccVAction	= 0x04,
	FnIndependence	= 0x08,
	FnMoveCountry	= 0x10,
	FnOfficer	= 0x20,
	FnRegularMutate	= 0x40
};
extern	unsigned int	FunctionSwitch;
extern	int InitialPopulation;
extern	double	InitialFoodStock;
#define FoodCosumingPerPerson	1.
#define FoodProductionPerLand	100.
extern	double FoodProductionPerWorker;
extern	double FoodSavingRate;
extern	double PopulationIncreasingRate;
extern	double FluctuationOfPopulation;
extern	double FluctuationOfProduction;
extern	int MaxSizeOfVillage;
extern	double OfficerA, OfficerB;
extern	double MutationWidth;
extern	unsigned long TracedCountryID, TracedVillageID;

// in main.c
extern void	*allocTempMem(int);
extern void	randomShuffle(void **, int);
extern double	gaussianRandom(void);
extern void	mutatedCopy(unsigned char *, unsigned char *, int);
extern void	setSimilarRGB(MyRGB *, MyRGB *);
extern int	emptyLand(void *);
extern void	occupyLand(Land *, Village *);
extern void	resetWorld(void);
extern void	restartWorld(void);
// in vil.c
extern Village	*newVillage(void);
extern void	registarCountry(Country *);
extern void	ruinCountry(Country *);
extern void	regularMutationVillage(Village *);
extern void	deliveryFoodsForVillage(Village *);
extern void	decideVillageAction(Village *);
extern void	moveCountry(Village *, Country *, Country *);
extern void	doVillageAction(Village *);
// in country.c
extern Country	*newCountry(void);
extern void	calcSurplus(Village *);
extern void	resetCountryLog(void);
extern void	showCountry(Country *);
